Bug 12537 - [3.3/3.4? Regression] g++ generates writeable text sections
Summary: [3.3/3.4? Regression] g++ generates writeable text sections
Status: RESOLVED FIXED
Alias: None
Product: gcc
Classification: Unclassified
Component: target (show other bugs)
Version: 3.3.2
: P2 normal
Target Milestone: 3.3.3
Assignee: Not yet assigned to anyone
URL:
Keywords: wrong-code
Depends on:
Blocks:
 
Reported: 2003-10-08 08:28 UTC by olh
Modified: 2004-01-17 04:22 UTC (History)
1 user (show)

See Also:
Host: powerpc-linux
Target: powerpc-linux
Build: powerpc-linux
Known to work:
Known to fail:
Last reconfirmed: 2003-10-09 14:11:39


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description olh 2003-10-08 08:28:23 UTC
toolchain:~ $ /home/toolchain/obj33/obj-gcc/gcc/xgcc -shared-libgcc -B/home/toolchain/obj33/obj-gcc/gcc/ -nostdinc++ -L/home/toolchain/obj33/obj-gcc/powerpc-unknown-linux-gnu/nof/libstdc++-v3/src -L/home/toolchain/obj33/obj-gcc/powerpc-unknown-linux-gnu/nof/libstdc++-v3/src/.libs -B/home/toolchain/gcc33/powerpc-unknown-linux-gnu/bin/ -B/home/toolchain/gcc33/powerpc-unknown-linux-gnu/lib/ -isystem /home/toolchain/gcc33/powerpc-unknown-linux-gnu/include -msoft-float -fPIC -mstrict-align -I/home/toolchain/gcc-3_3-branch/libstdc++-v3/../gcc -I/home/toolchain/gcc-3_3-branch/libstdc++-v3/../include -I/home/toolchain/obj33/obj-gcc/powerpc-unknown-linux-gnu/nof/libstdc++-v3/include/powerpc-unknown-linux-gnu -I/home/toolchain/obj33/obj-gcc/powerpc-unknown-linux-gnu/nof/libstdc++-v3/include -I/home/toolchain/gcc-3_3-branch/libstdc++-v3/libsupc++ -O1 -fsigned-char -g -Wall -fmessage-length=0 -D_GNU_SOURCE -msoft-float -fPIC -mstrict-align -fno-implicit-templates -Wall -Wno-format -W -Wwrite-strings -fdiagnostics-show-location=once -ffunction-sections -fdata-sections -c /home/toolchain/gcc-3_3-branch/libstdc++-v3/libsupc++/del_op.cc  -fPIC -DPIC -o del_op.o --save-temps -v 
Reading specs from /home/toolchain/obj33/obj-gcc/gcc/specs
Configured with: /home/toolchain/gcc-3_3-branch/configure --prefix=/home/toolchain/gcc33 --enable-languages=c,c++ --enable-version-specific-runtime-libs --disable-nls
Thread model: posix
gcc version 3.3.2 20031004 (prerelease)
 /home/toolchain/obj33/obj-gcc/gcc/cc1plus -E -D__GNUG__=3 -quiet -nostdinc++ -v -I/home/toolchain/gcc-3_3-branch/libstdc++-v3/../gcc -I/home/toolchain/gcc-3_3-branch/libstdc++-v3/../include -I/home/toolchain/obj33/obj-gcc/powerpc-unknown-linux-gnu/nof/libstdc++-v3/include/powerpc-unknown-linux-gnu -I/home/toolchain/obj33/obj-gcc/powerpc-unknown-linux-gnu/nof/libstdc++-v3/include -I/home/toolchain/gcc-3_3-branch/libstdc++-v3/libsupc++ -iprefix /home/toolchain/obj33/obj-gcc/gcc/../lib/gcc-lib/powerpc-unknown-linux-gnu/3.3.2/ -isystem /home/toolchain/obj33/obj-gcc/gcc/include -isystem /home/toolchain/gcc33/powerpc-unknown-linux-gnu/bin/include -isystem /home/toolchain/gcc33/powerpc-unknown-linux-gnu/lib/include -D__GNUC__=3 -D__GNUC_MINOR__=3 -D__GNUC_PATCHLEVEL__=2 -D_GNU_SOURCE -D__PIC__=2 -D__pic__=2 -D__unix__ -D__gnu_linux__ -D__linux__ -Dunix -D__unix -Dlinux -D__linux -Asystem=unix -Asystem=posix -D_GNU_SOURCE -DPIC -isystem /home/toolchain/gcc33/powerpc-unknown-linux-gnu/include /home/toolchain/gcc-3_3-branch/libstdc++-v3/libsupc++/del_op.cc -msoft-float -mstrict-align -msoft-float -mstrict-align -Wall -Wall -Wno-format -W -Wwrite-strings -fPIC -fsigned-char -fmessage-length=0 -fPIC -fno-implicit-templates -fdiagnostics-show-location=once -ffunction-sections -fdata-sections -fPIC -O1 del_op.ii
ignoring nonexistent directory "/home/toolchain/gcc33/powerpc-unknown-linux-gnu/bin/include"
ignoring nonexistent directory "/home/toolchain/gcc33/powerpc-unknown-linux-gnu/lib/include"
ignoring nonexistent directory "/home/toolchain/gcc33/powerpc-unknown-linux-gnu/include"
ignoring nonexistent directory "/home/toolchain/obj33/obj-gcc/lib/gcc-lib/powerpc-unknown-linux-gnu/3.3.2/include"
ignoring nonexistent directory "/home/toolchain/obj33/obj-gcc/lib/gcc-lib/powerpc-unknown-linux-gnu/3.3.2/../../../../powerpc-unknown-linux-gnu/include"
ignoring nonexistent directory "/usr/local/include"
ignoring nonexistent directory "/home/toolchain/gcc33/powerpc-unknown-linux-gnu/include"
#include "..." search starts here:
#include <...> search starts here:
 /home/toolchain/gcc-3_3-branch/gcc
 /home/toolchain/gcc-3_3-branch/include
 /home/toolchain/obj33/obj-gcc/powerpc-unknown-linux-gnu/nof/libstdc++-v3/include/powerpc-unknown-linux-gnu
 /home/toolchain/obj33/obj-gcc/powerpc-unknown-linux-gnu/nof/libstdc++-v3/include
 /home/toolchain/gcc-3_3-branch/libstdc++-v3/libsupc++
 /home/toolchain/obj33/obj-gcc/gcc/include
 /home/toolchain/gcc33/include
 /home/toolchain/gcc33/lib/gcc-lib/powerpc-unknown-linux-gnu/3.3.2/include
 /usr/include
End of search list.
 /home/toolchain/obj33/obj-gcc/gcc/cc1plus -fpreprocessed del_op.ii -quiet -dumpbase del_op.cc -msoft-float -mstrict-align -msoft-float -mstrict-align -auxbase-strip del_op.o -g -O1 -Wall -Wall -Wno-format -W -Wwrite-strings -version -fPIC -fsigned-char -fmessage-length=0 -fPIC -fno-implicit-templates -fdiagnostics-show-location=once -ffunction-sections -fdata-sections -fPIC -o del_op.s
GNU C++ version 3.3.2 20031004 (prerelease) (powerpc-unknown-linux-gnu)
        compiled by GNU C version 3.3.2 20031004 (prerelease).
GGC heuristics: --param ggc-min-expand=72 --param ggc-min-heapsize=80369
 /home/toolchain/gcc33/powerpc-unknown-linux-gnu/bin/as -mppc -V -Qy -K PIC -o del_op.o del_op.s
GNU assembler version 2.14.90 (powerpc-unknown-linux-gnu) using BFD version 2.14.90 20031004
del_op.s: Assembler messages:
del_op.s:13: Warning: setting incorrect section attributes for .text._ZdlPv
toolchain:~ $ grep -C2 .text._ZdlPv del_op.s
        .file 2 "/home/toolchain/obj33/obj-gcc/gcc/include/stddef.h"
        .file 3 "/home/toolchain/gcc-3_3-branch/libstdc++-v3/libsupc++/new"
        .section        .text._ZdlPv,"awx",@progbits
        .align 2
        .globl _ZdlPv


o-ton Modra:

<alanm> heh, writable text section.  bug in gcc
> 3.3.2 blocker?
<alanm> yeah, i'd say so.  this was current gcc-3.3 branch, ie. without any other patches?
Comment 1 Alan Modra 2003-10-09 14:11:38 UTC
This is a longstanding bug in the ppc32 back end.  Recent binutils correctly
complains when setting silly section attributes.
See http://gcc.gnu.org/ml/gcc-patches/2003-01/msg02345.html and
http://gcc.gnu.org/ml/gcc-patches/2003-02/msg00554.html
Comment 2 Mark Mitchell 2003-10-16 19:05:03 UTC
This is a pretty serious bug -- but there doesn't seem to be any clear consensus
on how to fix it yet, so I'm postponing it until GCC 3.3.3.
Comment 3 Alan Modra 2003-12-10 23:26:28 UTC
Fixed on 3.4 with http://gcc.gnu.org/ml/gcc-cvs/2003-11/msg00892.html
Fixed for 3.3.3 too.
Comment 4 Laurent Bigonville 2003-12-14 23:34:40 UTC
Today I try to build a debian package (openh323) and i get those warnings on
every files... I use the last version of gcc in sid:

g4:~# gcc -v
Lecture des spécification à partir de
/usr/lib/gcc-lib/powerpc-linux/3.3.3/specsConfiguré avec: ../src/configure -v
--enable-languages=c,c++,java,f77,pascal,objc,ada --prefix=/usr
--mandir=/usr/share/man --infodir=/usr/share/info
--with-gxx-include-dir=/usr/include/c++/3.3 --enable-shared --with-system-zlib
--enable-nls --without-included-gettext --enable-__cxa_atexit
--enable-clocale=gnu --enable-java-gc=boehm --enable-java-awt=xlib
--enable-objc-gc --disable-multilib powerpc-linux
Modèle de thread: posix
version gcc 3.3.3 20031206 (prerelease) (Debian)

Same problem on the debian's build machine...
http://buildd.debian.org/fetch.php?&pkg=openh323&ver=1.12.2-3&arch=powerpc&stamp=1065914698&file=log&as=raw